# coding: utf-8

"""
    Permify API

    Permify is an open source authorization service for creating fine-grained and scalable authorization systems.

    The version of the OpenAPI document: v1.0.1
    Contact: hello@permify.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class FunctionType(BaseModel):
    """
    Function type with result and arg types.
    """ # noqa: E501
    result_type: Optional[V1alpha1Type] = Field(default=None, alias="resultType")
    arg_types: Optional[List[V1alpha1Type]] = Field(default=None, description="Argument types of the function.", alias="argTypes")
    __properties: ClassVar[List[str]] = ["resultType", "argTypes"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FunctionType from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of result_type
        if self.result_type:
            _dict['resultType'] = self.result_type.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in arg_types (list)
        _items = []
        if self.arg_types:
            for _item_arg_types in self.arg_types:
                if _item_arg_types:
                    _items.append(_item_arg_types.to_dict())
            _dict['argTypes'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FunctionType from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "resultType": V1alpha1Type.from_dict(obj["resultType"]) if obj.get("resultType") is not None else None,
            "argTypes": [V1alpha1Type.from_dict(_item) for _item in obj["argTypes"]] if obj.get("argTypes") is not None else None
        })
        return _obj

from permify.models.v1alpha1_type import V1alpha1Type
# TODO: Rewrite to not use raise_errors
FunctionType.model_rebuild(raise_errors=False)

